function starList = centroider(pic, w, numstars)
% w is the w of the centroided stars

global C

if nargin < 2, w = 1; end
dims = size(pic);

picext = [zeros(w, dims(2)+2*w); ...
	[zeros(dims(1), w) pic zeros(dims(1), w)];
	zeros(w, dims(2)+2*w)];

masses = zeros(numstars,1);
ctd_ctrxs = zeros(numstars,1);
ctd_ctrys = zeros(numstars,1);

for i = 1:numstars
	[I J] = max(picext(:));	
	[x y] = ind2sub(size(picext), J);
	masses(i) = sum(sum(picext(x-w:x+w, y-w:y+w)));
	ctd_ctrxs(i) = sum([x-w:x+w] * picext(x-w:x+w, y-w:y+w))/masses(i);
	ctd_ctrys(i) = sum(picext(x-w:x+w, y-w:y+w) * [y-w:y+w]')/masses(i);	
		picext(x-w:x+w, y-w:y+w) = 0;
end

starList = [ctd_ctrxs-w ctd_ctrys-w masses];
