function x = invPfun(y, depth)
  global C;
  global pyramid;
  if nargin < 2
    depth = C.lgn;
  end
  z = y(:);
  nextlevel = reshape(z(pyramid.location(1)), 1, 1);
  for lvl = 1:depth
    side = 2.^(lvl-1);
    thislevel = nextlevel;
    nextlevel = reshape(z(pyramid.location(lvl+1):pyramid.location(lvl+2)-1), 2*side, 2*side);
    offsets = [0 0;0 1; 1 0; 1 1];
    obslevel = halfresolution(nextlevel);
    surplus = thislevel / 2 - obslevel;
    [row, col] = find(surplus);
    for i = 1:size(row)
      val = surplus(row(i),col(i));
      for j = 1:4
        ind = sub2ind(size(nextlevel), 2*row(i)-1 + offsets(j, 1), 2*col(i)-1 + offsets(j, 2));
        if (nextlevel(ind) * val < 0)
          if ((nextlevel(ind) + val)*val  < 0)
            nextlevel(ind) = nextlevel(ind) + val;
            val = 0;
          else
            val = val + nextlevel(ind);
            nextlevel(ind) = 0;
          end
        end
      end
      surplus(row(i),col(i)) = val;
    end
    changes = dupRows(dupRows(surplus)')' ./ 4;
    nextlevel = nextlevel + changes;

  end
  if nargin < 2
    x = nextlevel(:);
  else
    x = nextlevel;
  end
end

function x = dupRows(z)
  %[a b; c d] -> [a b; a b; c d; c d]
  x = reshape([z(:) z(:)]', [], size(z, 2));
end

