function result = recompose_wavelet(im, level)
  if nargin < 2
    level = log2(numel(im))/2;
  end

  side = sqrt(numel(im));

  if level == 0
    result = reshape(im, side, side);
    return
  end

  width = side^2/4;
  higher_level = recompose_wavelet(im(1:width), level-1);
  tr = reshape(im(width+1:2*width), side/2, side/2);
  bl = reshape(im(2*width+1:3*width), side/2, side/2);
  br = reshape(im(3*width+1:4*width), side/2, side/2);
  result = [higher_level tr; bl br];
end
